import 'dart:math';

import 'package:flutter_query/src/query_cache.dart';
import 'package:flutter_query/src/types.dart';

// TODO: ONLY STRING KEYS ARE SUPPORTED RIGHT NOW
final stableStringify = (dynamic value) {
  return value;
};

// TODO: Convert this
// final stableStringifyReplacer = (String key, dynamic value) {
//   if (value is Function) {
//     throw new Error();
//   }

//   // TODO: Convert this
//   // if (value is Object) {
//   //   return Object.keys(value)
//   //     .sort()
//   //     .reduce((result, key) => {
//   //       result[key] = value[key]
//   //       return result
//   //     }, {} as any)
//   // }

//   return value;
// };

final defaultQueryKeySerializerFn = (queryKey) {
  try {
    final arrayQueryKey = queryKey is List ? queryKey : [queryKey];
    final queryHash = stableStringify(arrayQueryKey);
    return [queryHash, arrayQueryKey];
  } catch (e) {
    throw new Exception('A valid query key is required!');
  }
};

final defaultConfig = ReactQueryConfig(
  queries: QueryObserverConfig(
    cacheTime: 5 * 60 * 1000,
    enabled: true,
    notifyOnStatusChange: true,
    queryFn: () => Future.error(''),
    queryKeySerializerFn: defaultQueryKeySerializerFn,
    refetchOnMount: true,
    refetchOnReconnect: true,
    retry: 3,
    retryDelay: (attemptIndex) => min(pow(1000 * 2, attemptIndex), 30000),
    staleTime: 0,
    structuralSharing: true,
  ),
);

// TODO: This is pretty duct taped together right now. Fix and refer to react source
ResolvedQueryConfig getResolvedQueryConfig(
  QueryCache queryCache,
  dynamic queryKey,
  ReactQueryConfig contextConfig,
  BaseQueryConfig config,
) {
  final queryCacheConfig = queryCache.getDefaultConfig();

  // This is temporary
  final resolvedConfig = ResolvedQueryConfig(
    cacheTime: queryCacheConfig?.cacheTime ?? 5 * 60 * 1000,
    enabled: true,
    notifyOnStatusChange: true,
    queryFn: () => Future.error(''),
    queryKeySerializerFn: defaultQueryKeySerializerFn,
    refetchOnMount: true,
    refetchOnReconnect: true,
    retry: 3,
    retryDelay: (attemptIndex) => min(pow(1000 * 2, attemptIndex), 30000),
    staleTime: 0,
    structuralSharing: true,
  );

  // final result = resolvedConfig.queryKeySerializerFn(queryKey);

  resolvedConfig.queryCache = queryCache;
  resolvedConfig.queryHash = queryKey;
  resolvedConfig.queryKey = queryKey;

  return resolvedConfig;
}

isResolvedQueryConfig(
  ResolvedQueryConfig config,
) {
  return config.queryHash != null;
}
