// TYPES

import 'package:flutter_query/src/utils.dart';

typedef NotifyCallback = void Function();

// CLASS

class NotifyManager {
  // private
  List<NotifyCallback> queue;

  // private
  int transactions;

  NotifyManager() {
    this.queue = [];
    this.transactions = 0;
  }

  T batch<T>(Function callback) {
    this.transactions++;
    final result = callback();
    this.transactions--;
    if (this.transactions == null) {
      this.flush();
    }
    return result;
  }

  void schedule(NotifyCallback notify) {
    // if (this.transactions != null) {
    //   this.queue.add(notify);
    // } else {
    //   scheduleMicrotask(() => {notify()});
    // }
    // TODO: Get this to actually work
    notify();
  }

  void flush() {
    final queue = this.queue;
    this.queue = [];
    if (queue.length > 0) {
      Future(() {
        final batchedUpdates = getBatchedUpdates();
        batchedUpdates(() => queue.forEach((notify) => notify()));
      });
    }
  }
}

// SINGLETON

final notifyManager = NotifyManager();
