import 'package:flutter_query/src/types.dart';

final noop = () {
  return Future.value();
};

final sleep = (int timeout) {
  return Future.delayed(Duration(milliseconds: timeout));
};

// TODO: Make sure this is valid
final isValidTimeout = (value) {
  return value is num && value >= 0 && value != double.maxFinite;
};

final getQueryArgs = <TResult, TError, TOptions>([arg1, arg2, arg3, arg4]) {
  var queryKey;
  Function queryFn;
  BaseQueryConfig config;
  TOptions options;

  // TODO: Convert this

  // if (arg1 is) {
  //   queryKey = arg1.queryKey
  //   queryFn = arg1.queryFn
  //   config = arg1.config
  //   options = arg2
  // } else if (isPlainObject(arg2)) {
  //   queryKey = arg1
  //   config = arg2
  //   options = arg3
  // } else {
  //   queryKey = arg1
  //   queryFn = arg2
  //   config = arg3
  //   options = arg4
  // }

  // config = config || {}

  // if (queryFn) {
  //   config = { ...config, queryFn }
  // }

  // return [queryKey, config, options]
  return [];
};

final functionalUpdate = (
  dynamic updater,
  dynamic input,
) {
  return updater is Function ? updater(input) : updater;
};

/**
 * Schedules a microtask.
 * This can be useful to schedule state updates after rendering.
 */
final scheduleMicrotask = (Function callback) {
  Future.value().then(callback).catchError((error) {
    throw error;
  });
};

typedef BatchUpdateFunction = void Function(Function callback);

// Default to a dummy "batch" implementation that just runs the callback
var batchedUpdates = (Function callback) {
  callback();
};

// Allow injecting another batching function later
final setBatchedUpdates = (BatchUpdateFunction fn) {
  batchedUpdates = fn;
};

// Supply a getter just to skip dealing with ESM bindings
final getBatchedUpdates = () {
  return batchedUpdates;
};

final isCancelledError = (value) {
  return value is CancelledError;
};

final isCancelable = (value) {
  if (value is Cancelable) {
    return value.cancel is Function;
  } else {
    return false;
  }
};

class Cancelable {
  void cancel() {}
}

class CancelledError {
  bool silent;
  CancelledError([bool silent]) {
    this.silent = silent;
  }
}
